'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _elementType = require('rsuite-utils/lib/propTypes/elementType');

var _elementType2 = _interopRequireDefault(_elementType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  prefixClass: _propTypes2.default.string,
  componentClass: _elementType2.default,
  icon: _propTypes2.default.string.isRequired,
  size: _propTypes2.default.oneOf(['lg', '2x', '3x', '4x', '5x']),
  flip: _propTypes2.default.oneOf(['horizontal', 'vertical']),
  stack: _propTypes2.default.oneOf(['1x', '2x']),
  rotate: _propTypes2.default.number,
  fixedWidth: _propTypes2.default.bool,
  spin: _propTypes2.default.bool,
  pulse: _propTypes2.default.bool
};

var defaultProps = {
  componentClass: 'i',
  prefixClass: 'icon',
  size: null,
  flip: null,
  rotate: null,
  stack: null,
  fixedWidth: false,
  spin: false,
  pulse: false
};

var IconFont = function (_React$Component) {
  _inherits(IconFont, _React$Component);

  function IconFont() {
    _classCallCheck(this, IconFont);

    return _possibleConstructorReturn(this, (IconFont.__proto__ || Object.getPrototypeOf(IconFont)).apply(this, arguments));
  }

  _createClass(IconFont, [{
    key: 'render',
    value: function render() {
      var _classNames;

      var _props = this.props,
          Component = _props.componentClass,
          className = _props.className,
          prefixClass = _props.prefixClass,
          icon = _props.icon,
          size = _props.size,
          fixedWidth = _props.fixedWidth,
          spin = _props.spin,
          pulse = _props.pulse,
          rotate = _props.rotate,
          flip = _props.flip,
          stack = _props.stack,
          props = _objectWithoutProperties(_props, ['componentClass', 'className', 'prefixClass', 'icon', 'size', 'fixedWidth', 'spin', 'pulse', 'rotate', 'flip', 'stack']);

      var classes = (0, _classnames2.default)('' + prefixClass, prefixClass + '-' + icon, (_classNames = {}, _defineProperty(_classNames, prefixClass + '-' + size, size), _defineProperty(_classNames, prefixClass + '-fw', fixedWidth), _defineProperty(_classNames, prefixClass + '-spin', spin), _defineProperty(_classNames, prefixClass + '-pulse', pulse), _defineProperty(_classNames, prefixClass + '-flip-' + flip, flip), _defineProperty(_classNames, prefixClass + '-rotate-' + rotate, rotate), _defineProperty(_classNames, prefixClass + '-stack-' + stack, stack), _classNames), className);

      return _react2.default.createElement(Component, _extends({}, props, { className: classes }));
    }
  }]);

  return IconFont;
}(_react2.default.Component);

IconFont.propTypes = propTypes;
IconFont.defaultProps = defaultProps;

exports.default = IconFont;