'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function find(children, func, context) {
  var index = 0;
  var result = void 0;

  _react2.default.Children.forEach(children, function (child) {
    if (result) {
      return;
    }
    index += 1;
    if (func.call(context, child, index)) {
      result = child;
    }
  });

  return result;
}

function map(children, func, context) {
  var index = 0;
  return _react2.default.Children.map(children, function (child) {
    if (!_react2.default.isValidElement(child)) {
      return child;
    }
    index += 1;
    return func.call(context, child, index);
  });
}

function mapCloneElement(children, func, context) {
  return map(children, function (child, index) {
    return _react2.default.cloneElement(child, _extends({
      key: index
    }, func(child, index)));
  }, context);
}

exports.default = {
  mapCloneElement: mapCloneElement,
  map: map,
  find: find
};